%%
%% $Id: appbcpatchmap.tex,v 1.5 2003-03-07 10:01:20 baurma Exp $
%%

\section{JNukeBCPatchMap}

The \texttt{JNukeBCPatchMap} object provides a bidirectional byte
code location transition map that is used by the instrumentation
facility.

\subsection{Constructor}

\code{
JNukeObj * \\
JNukeBCPatchMap\_new ( \\
\tab	JNukeObj * mem \\
)
}

\subsubsection{Description}

Create a new instance of a \texttt{JNukeBCPatchMap} object. The memory
required for this operation is drawn from a memory manager object.

\subsubsection{Parameters}

\begin{description}
\ttitem{mem}
	Reference to a memory manager object.
\end{description}

\subsubsection{Return value}

A new instance of a \texttt{JNukeBCPatchMap} object.

\subsection{JNukeBCPatchMap\_moveInstruction}

\code{
void \\
JNukeBCPatchMap\_moveInstruction ( \\
\tab	JNukeObj * this, \\
\tab	const int origfrom, \\
\tab	const int origto \\
)
}

\subsubsection{Description}

Register the intention of moving a particular bytecode
instruction.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to the patch map object
\ttitem{origfrom}
	Original bytecode address in the uninstrumented program
	that should be moved.
\ttitem{origto}
	New target bytecode location in the address space of the
	uninstrumented program if the instruction would have
	been moved.
\end{description}

\subsubsection{Return value}

None.


\subsection{JNukeBCPatchMap\_commitMoves}

\code{
void \\
JNukeBCPatchMap\_commitMoves ( \\
\tab	JNukeObj * this \\
)
}

\subsubsection{Description}

Commit all registered moves. After a commit is done, the first phase
of instrumentation is completed and no further intentions of moving
an instruction may be registered with the transition map.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to the patch map object
\end{description}

\subsubsection{Return value}

None.


\subsection{JNukeBCPatchMap\_translate}

\code{
int \\
JNukeBCPatchMap\_translate ( \\
\tab	const JNukeObj * this, \\
\tab	const int origfrom \\
)
}

\subsubsection{Description}

Given a bytecode address in the uninstrumented program, return its
corresponding new address when all previously registered changes would
have been applied to the bytecode. This method may not be called
on uncommitted transition maps.

Note that the function \texttt{JNukeBCPatchMap\_translateReverse}
performs the exact opposite address translation.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to the patch map object
\ttitem{origfrom}
	Original bytecode offset in the uninstrumented program whose
	final location in the instrumented program should be determined.
\end{description}

\subsubsection{Return value}

The new location of the instruction in the instrumented program.

\subsection{JNukeBCPatchMap\_translateReverse}

\code{
int \\
JNukeBCPatchMap\_translateReverse ( \\
\tab	const JNukeObj * this, \\
\tab	const int newfrom, \\
\tab	const JNukeObj * bc\_vec \\
)
}

\subsubsection{Description}


Given the final location in an instrumented program, return its original 
address in the uninstrumented program. This function may not be executed
on uncommitted transition maps. 

Note that the function \texttt{JNukeBCPatchMap\_translate}
performs the exact opposite address translation.


\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to the patch map object
\ttitem{newfrom}
	Target location of the instruction in the instrumented program
	whose address should be translated back to the original
	uninstrumented program.
\ttitem{bc\_vec}
	Reference to a vector of bytecodes of the method. The vector
	is used for verification of the result.
\end{description}

\subsubsection{Return value}


